<?php include("inc/pagestart.php"); ?>
<?php include("inc/header.php"); ?>
<?php include("inc/contentstart.php"); ?>
<?php

  class rss_parser {
    var $parser;
    var $data = array();
    var $initem = false;
    var $curitem;
    var $curtag;

    function startElement($parser, $name, $attrs)
    {
      if ($name == "A")
        return;

      $this->curtag = $name;
      if ($name == "ITEM") {
        $this->curitem = array();
        $this->initem = true;
      }
    }

    function endElement($parser, $name)
    {
      if ($name == "ITEM") {
        $this->data[] = $this->curitem;
        $this->initem = false;
      }
    }

    function characterData($parser, $cdata)
    {
      if ($this->initem) {
        $this->curitem[$this->curtag] .= $cdata;
      }
    }

   function rss_parser()
   {
      $this->parser = xml_parser_create();
      xml_set_object($this->parser, $this);
      xml_set_element_handler($this->parser, "startElement", "endElement");
      xml_set_character_data_handler($this->parser, "characterData");
   }

   function parse($data) {
      xml_parse($this->parser, $data);
      return $this->data;
   }
  }

  $post_id = 17140;
  print('<table cellpadding="0" cellspacing="0" border="0"><tr valign="top"><td width="50%">');
  print('<div class="headline">The Spring Project</div><br>');
  include("inc/showcontent.php");
  print('</td><td width="1"><img src="/res/trans.gif" width="6" height="10" border="0">');
  print('</td><td width="1" bgcolor="#000000"><img src="/res/trans.gif" width="1" height="10" border="0">');
  print('</td><td width="1"><img src="/res/trans.gif" width="10" height="10" border="0">');
  print('</td><td width="50%">');

  print('<table cellpadding="0" cellspacing="0" border="0" width="100%"><tr valign="bottom">');
  print('<td class="headline">Latest community news</td>');
  print('<td style="font-size: 10px;" align="right">Click items to read more..</td>');
  print('</tr></table><br>');

  $data = file_get_contents('community.xml');
  $parser = new rss_parser();
  $xml = $parser->parse($data);
//  print_r($xml);

  $count = 0;
  foreach($xml as $item) {
    if ($count > 0) {
      print('<br><br>');
    }
  	print('<a href="' . $item['LINK'] . '">' . $item['TITLE'] . '</a><br>');
//    print('<div style="font-size: 10px;">' . $item['DESCRIPTION'] . '</font>');
    //print($item['DESCRIPTION']);
    $btext = $item['DESCRIPTION'];

	preg_match_all('/\[(.*?) (.*)\]/', $btext, $wlinks, PREG_SET_ORDER);
    foreach ($wlinks as $wset) {
        $link = '<a href="' . $wset[1] . '" style="font-weight: normal; color: #0066bb;">' . $wset[2] . '</a>';
        $btext = str_replace($wset[0], $link, $btext);
    }
    print($btext);

    $count++;
    if ($count > 2)
      break;
  }

  print('</td></tr></table>');

  include("inc/hr-wide.php");
?>
<div class="headline">Latest developer news</div><br>
<?php
	//Get a bbcode parser as $bbcode
/*	include("inc/bbcode.inc.php");
	include("inc/bbcodesetup.php");

  include("inc/hidemail.php"); */
/*
  print('<font size="small">');
  print("So, what is happening with the site? I don't know really. It would seem the forum database has been corrupted in some way. Unfortunately I have managed to backup the other databases on the server, but not that one. So there will probably be quite a bit of lost posts and stuff.. Sorry about that.<br><br><br>");
  print("</font>"); */

//  print("I am aware of this. :)<br><br><br>");

//  include("inc/db.php");

  $sql = "";
  $sql .= "SELECT t.topic_id, topic_poster, pt.post_text, u.username, u.user_email, t.topic_time, t.topic_replies, t.topic_title ";
  $sql .= "FROM phpbb_topics AS t, phpbb_users AS u, phpbb_posts AS p, phpbb_posts_text AS pt ";
  $sql .= "WHERE t.forum_id = 2 AND t.topic_poster = u.user_id AND t.topic_id = p.topic_id AND t.topic_time = p.post_time AND pt.post_id = p.post_id ";
  $sql .= "ORDER  BY t.topic_time DESC ";
  $sql .= "LIMIT 10";

  $res = mysql_query($sql);

  //Count the rows
  for ($i = 0; ; $i++) {

    //Try to get the next item
    $row = mysql_fetch_assoc($res);
    if ($row == "")
    	break;

    //Print a divider
    if ($i > 0) {
      include("inc/hr-small.php");
    }

    //Retrieve the fields to variables
    $id = $row['topic_id'];
    $poster = $row['topic_poster'];
    $time = $row['topic_time'];
    $numcomm = $row['topic_replies'];
    $title = $row['topic_title'];
    $username = $row['username'];
    $usermail = $row['user_email'];
    $text = $row['post_text'];

    //Do extra parsing
    $text = $bbcode->parse($text);
    $time = date("Y-m-d H:i", $time);

    print("<b>$title</b><br>");
    print($text);
    print("<br><br>");
    print('<font size="-2">');
    print("Posted by " . hidemail($usermail, $username, -2) . " at $time, ");
    print('<a href="/phpbb/viewtopic.php?t=' . $id . '"><font size="-2">');
    print("$numcomm comment");
    if ($numcomm != 1)
    	print("s");
    print('</font></a>');
    print('</font><br><br>');
  }

?>

<?php include("inc/contentend.php"); ?>
<?php include("inc/footer.php"); ?>
<?php include("inc/pageend.php"); ?>